import numpy as np
import matplotlib.pyplot as plt
plt.ion()

def plotc(x,c=None):
	if c is None:
		plt.plot(x.imag,color="red")
		plt.plot(x.real,color="blue")
	else:
		plt.plot(x,c.imag,color="red")
		plt.plot(x,c.real,color="blue")

def plotabs(x,c=None):
	if c is None: plt.plot(  np.abs(x),color="blue")
	else:         plt.plot(x,np.abs(c),color="blue")

def plotang(x,c=None):
	if c is None: plt.plot(  np.unwrap(np.angle(x)),color="red")
	else:         plt.plot(x,np.unwrap(np.angle(c)),color="red")

def plotθ(x,c=None):
	plotang(x,c)
	plotabs(x,c)

# def plotθ(x,c=None):
# 	fig,ax = plt.subplots()
# 	plt.plot(np.unwrap(np.angle(x)),color="red")
# 	ax.set_xlabel("x", fontsize = 14)
# 	ax.set_ylabel("angle", color="red", fontsize=14)
# 	ax2=ax.twinx()
# 	ax2.plot(np.abs(x),color="blue")
# 	ax2.set_ylabel("abs",color="blue",fontsize=14)
# fig.savefig('two_different_y_axis_for_single_python_plot_with_twinx.jpg',
#             format='jpeg',
#             dpi=100,
#             bbox_inches='tight')

def vizθc(pulse,plotθc,mode=True):
	plt.clf()
	plt.tight_layout()
	plt.subplot(2,2,1) if mode else plt.subplot(1,2,1) 
	plotθc(pulse.T_ps,pulse.AT)
	plt.xlabel('time [ps]')
	plt.ylabel('AT')
	# plt.title("time")
	plt.subplot(2,2,2) if mode else plt.subplot(1,2,2) 
	plotθc(pulse.W_THz,pulse.AW)
	plt.xlabel('freq [THz]')
	plt.ylabel('AW')
	# plt.title("freq")
	if mode:
		plt.subplot(2,2,3)
		plotθc(pulse.calculate_intensity_autocorrelation(),pulse.AT)
		plt.title("auto-corr")
		plt.subplot(2,2,4)
		DELAYS, FREQS, extent, spectrogram = pulse.spectrogram()
		plt.imshow(spectrogram, aspect='auto', extent=extent)
		plt.xlabel('time [ps]')
		plt.ylabel('freq [THz]')
		plt.show(block=False)
		print(f"energy per pulse = {pulse.calc_epp()} [J]")
		pulse.center_frequency_THz
		pulse.center_wavelength_nm

def vizθ(pulse,mode=True): return vizθc(pulse,plotθ,mode)

def vizc(pulse,mode=True): return vizθc(pulse,plotc,mode)

def vizabs(pulse,mode=True): return vizθc(pulse,plotabs,mode)

def vizang(pulse,mode=True): return vizθc(pulse,plotang,mode)

def viz_pair(pulse1,pulse2):
	plt.clf()
	# plt.tight_layout()
	plt.subplot(2,2,1)
	plt.plot(pulse1.W_THz,np.abs(pulse1.AW))
	plt.xlabel('freq [THz]');plt.ylabel('abs(AW)')
	plt.subplot(2,2,2)
	plt.plot(pulse1.W_THz,np.unwrap(np.angle(pulse1.AW)))
	plt.xlabel('freq [THz]');plt.ylabel('angle(AW)')
	plt.subplot(2,2,3)
	plt.plot(pulse2.W_THz,np.abs(pulse2.AW))
	plt.xlabel('freq [THz]');plt.ylabel('abs(AW)')
	plt.subplot(2,2,4)
	plt.plot(pulse2.W_THz,np.unwrap(np.angle(pulse2.AW)))
	plt.xlabel('freq [THz]');plt.ylabel('angle(AW)')

def viz_pair_t(pulse1,pulse2):
	plt.clf()
	# plt.tight_layout()
	plt.subplot(2,2,1)
	plt.plot(pulse1.T_ps,np.abs(pulse1.AT))
	plt.xlabel('time [ps]');plt.ylabel('abs(AT)')
	plt.subplot(2,2,2)
	plt.plot(pulse1.T_ps,np.unwrap(np.angle(pulse1.AT)))
	plt.xlabel('time [ps]');plt.ylabel('angle(AT)')
	plt.subplot(2,2,3)
	plt.plot(pulse2.T_ps,np.abs(pulse2.AT))
	plt.xlabel('time [ps]');plt.ylabel('abs(AT)')
	plt.subplot(2,2,4)
	plt.plot(pulse2.T_ps,np.unwrap(np.angle(pulse2.AT)))
	plt.xlabel('time [ps]');plt.ylabel('angle(AT)')

# def vizio(pulse_in,pulse_out):
# 	F = pulse_in.F_THz # Frequency grid of pulse (THz)
# 	zW = dB(np.transpose(AW)[:, (F > 0)])
# 	zT = dB(np.transpose(AT))
# 	y_mm = y * 1e3 # convert distance to mm
# 	ax0.plot(pulse_out.F_THz, dB(pulse_out.AW), color = 'r')
# 	ax0.plot(pulse_in .F_THz, dB(pulse_in .AW), color = 'b')
# 	ax1.plot(pulse_out.T_ps , dB(pulse_out.AT), color = 'r')
# 	ax1.plot(pulse_in .T_ps , dB(pulse_in .AT), color = 'b')
# 	extent = (np.min(F[F > 0]), np.max(F[F > 0]), 0, Length)
# 	ax2.imshow(
# 		zW, extent=extent,
# 		vmin=np.max(zW) - 40.0,
# 		vmax=np.max(zW),
# 		aspect='auto', origin='lower'
# 	)
# 	extent = (np.min(pulse_in.T_ps), np.max(pulse_in.T_ps), np.min(y_mm), Length)
# 	ax3.imshow(
# 		zT, extent=extent,
# 		vmin=np.max(zT) - 40.0,
# 		vmax=np.max(zT),
# 		aspect='auto', origin='lower'
# 	)
# 	ax0.set_ylabel('Intensity (dB)')
# 	ax0.set_ylim( - 80,  0)
# 	ax1.set_ylim( - 40, 40)
# 	ax2.set_ylabel('Propagation distance (mm)')
# 	ax2.set_xlabel('Frequency (THz)')
# 	ax2.set_xlim(0,400)
# 	ax3.set_xlabel('Time (ps)')
# 	plt.show()

# pulseWL = 1550  # (nm) pulse central wavelength
# fibWL = pulseWL # (nm) Center WL of fiber

def dB(num): return 10 * np.log10(np.abs(num)**2)

